from synthegrator.code_problems import CodeProblem
import pytest
from synthegrator.synthdatasets import yield_problems_from_name, DatasetName
from synthegrator.synthdatasets.human_eval import yield_human_eval


def test_yield_from_dataset_names():
    data_by_name = list(yield_problems_from_name(
        DatasetName.humaneval,
        max_problems=5
    ))
    data_by_func = list(yield_human_eval(max_problems=5))
    assert data_by_name[0].working_directory == data_by_func[0].working_directory
    assert are_probs_eq(data_by_name[0], data_by_func[0])


@pytest.mark.parametrize(
    "dataset",
    set(DatasetName) - {DatasetName.dypy_line_completion, DatasetName.mbpp_sanatized},
)
def test_load_each_dataset(dataset):
    print(dataset)
    data = list(yield_problems_from_name(
        dataset,
        max_problems=1
    ))
    assert len(data) == 1
    assert data[0].dataset_name == dataset.get_base_collection_name()


def are_probs_eq(a: CodeProblem, b: CodeProblem):
    return bool(a == b)
